#define BLYNK_PRINT SerialUSB
//#define BLYNK_DEBUG SerialUSB

#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
#include <Adafruit_CircuitPlayground.h>

#include <Wire.h>
#include <SPI.h>

char auth[] = "ktmPD08zWxT1yrM_5-dslDrHkDtRh5sH";
char ssid[] = "rpilpel";
char pass[] = "0546555564";

#define EspSerial Serial1
#define ESP8266_BAUD 115200

ESP8266 wifi(&EspSerial);

void setup() {
  CircuitPlayground.begin();
  SerialUSB.begin(115200);
  EspSerial.begin(ESP8266_BAUD);
  delay(10);
  Blynk.begin(auth, wifi, ssid, pass);
  Serial.begin(115200);
  CircuitPlayground.strip.setBrightness(255);
  CircuitPlayground.strip.setPixelColor(1, 0, 255, 0);
  CircuitPlayground.strip.show();
}

bool slideSwitch;
bool leftButtonPressed;
bool rightButtonPressed;
float heart_rate;
int waterCounter;

void loop() {
  Blynk.run();
  slideSwitch = CircuitPlayground.slideSwitch();
  leftButtonPressed = CircuitPlayground.leftButton();
  rightButtonPressed = CircuitPlayground.rightButton();

  /*
    When starting the shift, write in google sheet my starting time, name and phone.
   */
  if (slideSwitch) {
    Blynk.virtualWrite(V2, 42);

    /*
      If the doc need help, it send a text message to all the working docs.
     */
    if (rightButtonPressed) {
      Blynk.virtualWrite(V4, 42);
    }
    /*
      If pressed by mistake, it send a text message of false alarm.
     */
    if (leftButtonPressed) {
      Blynk.virtualWrite(V5, 42);
    }

    /*
      Checking a patainet heartrate - can see on Blynk app.
     */
    int light = CircuitPlayground.lightSensor();
    heart_rate = 0.95 * heart_rate + 0.05 * light;
    Blynk.virtualWrite(V6, heart_rate);

    /*
      Checking a patainet temperature - can see on Blynk app.
     */
    int tempC = CircuitPlayground.temperature();
    Blynk.virtualWrite(V7, tempC);

    /*
      Once in an hour, notify the doctor to drink water.
     */
    if(waterCounter == 10000){
      for (int i = 0; i < 10; i++) {
        if(i != 1) {
          CircuitPlayground.setPixelColor(i, 0, 0, 255);
        }
      }
      CircuitPlayground.playTone(500, 100);
      delay(200);
      CircuitPlayground.playTone(500, 100);
      delay(1000);
      CircuitPlayground.clearPixels();
      CircuitPlayground.setPixelColor(1, 0, 255, 0);
      waterCounter == 0;
    }
    waterCounter += 10;
    delay(10);
  }
  else {
    Blynk.virtualWrite(V3, 42);
  }
}

/**
  When a new post on the facebook group
  turn on the CPX pixel lights in purple
  http://blynk-cloud.com/ktmPD08zWxT1yrM_5-dslDrHkDtRh5sH/update/V0?value=1
*/
BLYNK_WRITE(V0) {
  int groupAlert = param.asInt();
  if (groupAlert == 1) {
    for (int i = 0; i < 10; i++) {
      if(i != 1) {
        CircuitPlayground.setPixelColor(i, 131, 0, 183);
      }
    }
    delay(3000);
    circuitPlayground.clearPixels();
    CircuitPlayground.setPixelColor(1, 0, 255, 0);
  }
  else {
    CircuitPlayground.clearPixels();
    CircuitPlayground.setPixelColor(1, 0, 255, 0);
  }
}

/**
  When you press the button on the Blynk
  for inviting me, you should alert with pixel lights and beep
*/
BLYNK_WRITE(V1) {
  int inviteAlert = param.asInt();
  if (inviteAlert == 1) {
    for (int i = 0; i < 10; i++) {
      if(i != 1) {
        CircuitPlayground.setPixelColor(i, 0, 255, 0);
      }
    }
    CircuitPlayground.playTone(500, 100);
    delay(200);
    CircuitPlayground.playTone(500, 100);
  }
  delay(3000);
  CircuitPlayground.clearPixels();
  CircuitPlayground.setPixelColor(1, 0, 255, 0);
  inviteAlert == 0;
}

/**
  Sending a text input from Blynk app to open a webhook in intergromat
  Opening a MedicAPI with ID (user input) to get diagonsis. 
 */
BLYNK_WRITE(V10) {
  String str = param.asStr();
  Blynk.virtualWrite(V11, str);
}
